GRPC Core 0.10.0.0

- Main Page
- Data Structures
- Files

- File List
- Globals

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Data Structures | Typedefs | Enumerations | Functions
byte_buffer.h File Reference
`#include <grpc/compression.h>`
`#include <grpc/support/slice_buffer.h>`

Go to the source code of this file.

## Data Structures
struct | grpc_byte_buffer

## Typedefs
typedef struct grpc_byte_buffer | grpc_byte_buffer
typedef struct grpc_byte_buffer_reader | grpc_byte_buffer_reader

## Enumerations
enum | grpc_byte_buffer_type { GRPC_BB_RAW }

## Functions
grpc_byte_buffer * | grpc_raw_byte_buffer_create (gpr_slice *slices, size_t nslices)
| Returns a RAW byte buffer instance over the given slices (up to nslices). More...
grpc_byte_buffer * | grpc_raw_compressed_byte_buffer_create (gpr_slice *slices, size_t nslices, grpc_compression_algorithm compression)
| Returns a compressed RAW byte buffer instance over the given slices (up to nslices). More...
grpc_byte_buffer * | grpc_byte_buffer_copy (grpc_byte_buffer *bb)
| Copies input byte buffer bb. More...
size_t | grpc_byte_buffer_length (grpc_byte_buffer *bb)
| Returns the size of the given byte buffer, in bytes. More...
void | grpc_byte_buffer_destroy (grpc_byte_buffer *byte_buffer)
| Destroys byte_buffer deallocating all its memory. More...
void | grpc_byte_buffer_reader_init (grpc_byte_buffer_reader *reader, grpc_byte_buffer *buffer)
| Initialize reader to read over buffer. More...
void | grpc_byte_buffer_reader_destroy (grpc_byte_buffer_reader *reader)
| Cleanup and destroy reader. More...
int | grpc_byte_buffer_reader_next (grpc_byte_buffer_reader *reader, gpr_slice *slice)
| Updates slice with the next piece of data from from reader and returns. More...
grpc_byte_buffer * | grpc_raw_byte_buffer_from_reader (grpc_byte_buffer_reader *reader)
| Returns a RAW byte buffer instance from the output of reader. More...

## Typedef Documentation

typedef struct grpc_byte_buffer grpc_byte_buffer

typedef struct grpc_byte_buffer_reader grpc_byte_buffer_reader

## Enumeration Type Documentation

enum grpc_byte_buffer_type

Enumerator
GRPC_BB_RAW |

## Function Documentation

grpc_byte_buffer* grpc_byte_buffer_copy | ( | grpc_byte_buffer * | bb | ) |

Copies input byte buffer bb.

Increases the reference count of all the source slices. The user is responsible for calling grpc_byte_buffer_destroy over the returned copy.

void grpc_byte_buffer_destroy | ( | grpc_byte_buffer * | byte_buffer | ) |

Destroys byte_buffer deallocating all its memory.

size_t grpc_byte_buffer_length | ( | grpc_byte_buffer * | bb | ) |

Returns the size of the given byte buffer, in bytes.

void grpc_byte_buffer_reader_destroy | ( | grpc_byte_buffer_reader * | reader | ) |

Cleanup and destroy reader.

void grpc_byte_buffer_reader_init | ( | grpc_byte_buffer_reader * | reader,
|  | grpc_byte_buffer * | buffer
| ) |  |

Initialize reader to read over buffer.

int grpc_byte_buffer_reader_next | ( | grpc_byte_buffer_reader * | reader,
|  | gpr_slice * | slice
| ) |  |

Updates slice with the next piece of data from from reader and returns.

1. Returns 0 at the end of the stream. Caller is responsible for calling gpr_slice_unref on the result.

grpc_byte_buffer* grpc_raw_byte_buffer_create | ( | gpr_slice * | slices,
|  | size_t | nslices
| ) |  |

Returns a RAW byte buffer instance over the given slices (up to nslices).

Increases the reference count for all slices processed. The user is responsible for invoking grpc_byte_buffer_destroy on the returned instance.

grpc_byte_buffer* grpc_raw_byte_buffer_from_reader | ( | grpc_byte_buffer_reader * | reader | ) |

Returns a RAW byte buffer instance from the output of reader.

grpc_byte_buffer* grpc_raw_compressed_byte_buffer_create | ( | gpr_slice * | slices,
|  | size_t | nslices,
|  | grpc_compression_algorithm | compression
| ) |  |

Returns a compressed RAW byte buffer instance over the given slices (up to nslices).

The compression argument defines the compression algorithm used to generate the data in slices.

Increases the reference count for all slices processed. The user is responsible for invoking grpc_byte_buffer_destroy on the returned instance.